/*
 * @(#)SearchOptionsMockup9.java  0.01 07/06/2012
 *
 * Copyright 2012 GPL (Open Source)
 *
 */

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.basic.*;

import mmj.pa.ProofAsstException;
import mmj.tmff.TMFFException;
import mmj.tmff.TMFFFormat;

import mmj.search.*;
import mmj.pa.*;

/**
 *  Test class.
 */
public class SearchOptionsMockup9
				implements SearchOptionsButtonHandler {

	String 					version = "V8-210620082012";
	String 					title;

	ProofAsstPreferences 	proofAsstPreferences;
	SearchMgr               searchMgr;

    JFrame 					searchOptionsFrame;

	Box 					frameBox;

	SearchOptionsScrnMap 	searchOptionsScrnMap;

	Font   					font;
	int                     fontSize;

	boolean 				stepSearchMode;


	String[]	CHAP_VALUES  			= {
		 ""
		,"Chapter 1"
		,"Chapter 2"
	};

	String[][]	CHAP_SEC_VALUES		    = {
		{""},
		{"", "Chap 1 Sec 1", "Chap 1 Sec 2", "Chap 1 Sec 3",},
		{"", "Chap 2 Sec 1", "Chap 2 Sec 2", "Chap 2 Sec 3",}
	};

	String[][] 	FOR_WHAT_PRIOR_VALUES = {
		{ "ForWhat1: Prior Value [-1]     "
		 ,"ForWhat1: Prior Value [-2]     "
		 ,"ForWhat1: Prior Value [-3]     "
		 ,"ForWhat1: Prior Value [-4]     "
		 ,"ForWhat1: Prior Value [-5]     "
		 ,"ForWhat1: Prior Value [-6]     "
		 ,"ForWhat1: Prior Value [-7]     "
		 ,"ForWhat1: Prior Value [-8]     "
		 ,"ForWhat1: Prior Value [-9]     "}

	   ,{ "ForWhat2: Prior Value [-1]     "
		 ,"ForWhat2: Prior Value [-2]     "
		 ,"ForWhat2: Prior Value [-3]     "
		 ,"ForWhat2: Prior Value [-4]     "
		 ,"ForWhat2: Prior Value [-5]     "
		 ,"ForWhat2: Prior Value [-6]     "
		 ,"ForWhat2: Prior Value [-7]     "
		 ,"ForWhat2: Prior Value [-8]     "
		 ,"ForWhat2: Prior Value [-9]     "}

	   ,{ "ForWhat3: Prior Value [-1]     "
		 ,"ForWhat3: Prior Value [-2]     "
		 ,"ForWhat3: Prior Value [-3]     "
		 ,"ForWhat3: Prior Value [-4]     "
		 ,"ForWhat3: Prior Value [-5]     "
		 ,"ForWhat3: Prior Value [-6]     "
		 ,"ForWhat3: Prior Value [-7]     "
		 ,"ForWhat3: Prior Value [-8]     "
		 ,"ForWhat3: Prior Value [-9]     "}

	   ,{ "ForWhat4: Prior Value [-1]     "
		 ,"ForWhat4: Prior Value [-2]     "
		 ,"ForWhat4: Prior Value [-3]     "
		 ,"ForWhat4: Prior Value [-4]     "
		 ,"ForWhat4: Prior Value [-5]     "
		 ,"ForWhat4: Prior Value [-6]     "
		 ,"ForWhat4: Prior Value [-7]     "
		 ,"ForWhat4: Prior Value [-8]     "
		 ,"ForWhat4: Prior Value [-9]     "}

	};

	public SearchOptionsMockup9() {
	}

	public JFrame buildFrame(String[] args) {

		//---------------------------------------------------------------------

		proofAsstPreferences       = new ProofAsstPreferences();
		searchMgr                  =
			proofAsstPreferences.getSearchMgr();
		font                       = searchMgr.getSearchFont();
		fontSize                   = searchMgr.getSearchFontSize();

		if (args.length > 0 &&
		    args[0].equals("StepSearch")) {
			stepSearchMode        = true;
			title                 =
				"Step Search: Options - Step 999 Theorem tttttt LOC_AFTER n/a "
				+ version;
		}
		else {
			stepSearchMode        = false;
			title                 =
				"General Search: Options - Stmt tttttt LOC_AFTER n/a "
				+ version;
		}


        searchOptionsFrame		  = new JFrame(title);

        searchOptionsFrame.
        	setDefaultCloseOperation(
				JFrame.DISPOSE_ON_CLOSE);

		searchOptionsFrame.setFont(font);


		searchOptionsScrnMap 	  =
			new SearchOptionsScrnMap(
	                font,
	                this,       // i.e. a SearchOptionsButtonHandler
	                CHAP_VALUES,
	                CHAP_SEC_VALUES,
	                FOR_WHAT_PRIOR_VALUES,
	                stepSearchMode);

		searchOptionsScrnMap.positionCursor(
			SearchOptionsConstants.FOR_WHAT_0_FIELD_ID,
			0);

		frameBox              	  = Box.createVerticalBox();
        frameBox.add(searchOptionsScrnMap.getSearchOptionsBox());

        searchOptionsFrame.
        	getContentPane().
        		add(frameBox);

		return searchOptionsFrame;
	}

	public void searchOptionsButtonPressed(int buttonId) {
		switch (buttonId) {
			case SearchOptionsConstants.HELP_BUTTON_ID :
				searchMgr.showSearchOptionsHelp();
				break;

			case SearchOptionsConstants.PLUS_BUTTON_ID :
				fontSize          = searchMgr.increaseFontSize();
				updateSearchOptionsScrnMapFont();
				break;

			case SearchOptionsConstants.MINUS_BUTTON_ID :
				fontSize          = searchMgr.decreaseFontSize();
				updateSearchOptionsScrnMapFont();
				break;

			default :
				System.out.println(
					  "SearchOptions "
					+ SearchOptionsConstants.BUTTON_ATTR[buttonId].label
					+ " button pressed.");
				break;
		}
	}

	private void updateSearchOptionsScrnMapFont() {
		font              = searchMgr.getSearchFont();
		searchOptionsScrnMap.setSearchOptionsFont(font);
		searchOptionsFrame.pack();
	}

//===========================================================
//TEST FRAMEWORK FOLLOWS
//===========================================================
    /**
     *  Inner class used to display the Frame later on the
     *  event queue thread.
     *
     *  We construct the thing and establish it to
     *  be displayed on the event queue thread using
     *  "EventQueue.invokeLater()".
     */
    protected static class FrameShower implements Runnable {
        JFrame f;

        /**
         *  Constructor with Frame input.
         *
         *  We construct this thing and establish it to
         *  be displayed on the event queue thread.
         *
         *  @param showFrame is the Frame to be displayed
         */
        public FrameShower(JFrame showFrame) {
            f                     = showFrame;
        }

        /**
         *  Run code to display the frame on the event queue thread.
         */
        public void run() {
            f.pack();
            f.setVisible(true);
        }
    }

    /**
     *  Show the frame later on the event queue thread.
     *
     *  We construct the thing and establish it to
     *  be displayed on the event queue thread using
     *  "EventQueue.invokeLater()".
     *
     *  @param jFrame is the Frame to be displayed
     */
    public void showFrame(JFrame jFrame) {
        Runnable     runner       =
            new FrameShower(jFrame);

        EventQueue.invokeLater(runner);
    }

    /**
     *  main entry point for testing using defaults.
     *
     *  @param args Command line argument String array (not used).
     */
    public static void main(String[] args) {

        SearchOptionsMockup9 t     = new SearchOptionsMockup9();

        t.showFrame(
			t.buildFrame(args));
    }
}